<?php
/*
    Plugin Name: Remove Meta Generators
    Description: Remove all meta generator tags for all plugins. No settings necessary! Install and activate.
    Author: <a href="https://www.webbernaut.com">Webbernaut</a>
    Version: 1.0
*/

// Exit if accessed directly
if(!defined('ABSPATH')) exit;

// Set the version of this plugin
if(!defined('removeMetaGenerators')) {
    define('removeMetaGenerators', '1.0');
}

class removeMetaGenerators {

#Constructor
    function __construct() {
      //Hook up to the init action
      add_action('init', array(&$this, 'init_removeMetaGenerators'));
  } //end of construct

#Action init
    function init_removeMetaGenerators() {
        ini_set('output_buffering', 'on'); // turns on output_buffering
        function remove_meta_generators($html) {
            $pattern = '/<meta name(.*)=(.*)"generator"(.*)>/i';
            $html = preg_replace($pattern, '', $html);
            return $html;
        }
        function clean_meta_generators() {
            ob_start('remove_meta_generators');
        }
        add_action('get_header', 'clean_meta_generators', 100);
        add_action('wp_footer', function(){ ob_end_flush(); }, 100);
    } //end of init

} //end of class

new removeMetaGenerators();

//End of Plugin
?>
